#include <cstdio>
#include <cstdlib>
#include <vector>
#include "art.h"

namespace {
    const int QUESTION = 942318468,
                ANSWER = 539883183;
    int N;
}

int safely_read_int() {
    int i;
    if (scanf("%d", &i) != 1)
        return -1;
    return i;
}

int publish(std::vector<int> v) {
    if(v.size() != N) {
        printf("%d -1", QUESTION);
        exit(0);
    }
    printf("%d %d", QUESTION, (int) v.size());
    for(int x : v)
        printf(" %d", x);
    printf("\n");
    fflush(stdout);
    int x = safely_read_int();
    if(x == -1)
        exit(0);
    return x;
}

void answer(std::vector<int> v) {
    if(v.size() != N) {
        printf("%d -1", ANSWER);
        exit(0);
    }
    printf("%d %d", ANSWER, (int) v.size());
    for(int x : v)
        printf(" %d", x);
    printf("\n");
    fflush(stdout);
    exit(0);
}

int main() {
    N = safely_read_int();
    solve(N);
}
